theory ArrayVC = Main:

typedecl 'a array

consts
  arrayRead :: "'a array => int => 'a"
  arrayWrite :: "'a array => int => 'a => 'a array"
  newArray :: "int => 'a => 'a array"

axioms
  array1_def: "arrayRead (arrayWrite a i x) i = x"
  array2_def: "i ~= j ==> arrayRead (arrayWrite a i x) j = arrayRead a j"
  array3_def: "0 <= i & i < n ==> arrayRead (newArray n x) i = x"
  array4_def: "arraySize (arrayWrite a i x) = arraySize a"
  array5_def: "arraySize (newArray n x) = n"

constdefs
  cardleq1 :: "'a set => bool"
  "cardleq1 x == (x={} | (EX x0. x={x0}))"

constdefs
  cardeq1 :: "'a set => bool"
  "cardeq1 x == (EX x0. x={x0})"

consts
  fieldRead :: "'field => 'obj => 'val"
  fieldWrite :: "'field => 'obj => 'val => 'field"

axioms
  field1_def: "fieldRead (fieldWrite field obj val) obj = val"
  field2_def: "obj1 ~= obj2 --> fieldRead (fieldWrite field obj1 val) obj2 = fieldRead field obj2"
 
end