theory "PriorityQueue-lemmas" = ArrayVC:

lemma div_ge_1: "(1::int) < x ==> 1 <= x div 2"
apply (subgoal_tac "2 div (2::int) <= x div (2::int)")
apply force
apply (rule zdiv_mono1)
apply force
apply force
done

lemma div_mono_gt0: "(0::int) <= x ==> x div (2::int) <= x"
apply (subgoal_tac "x div (2::int) <= x div (1::int)")
apply force
apply (rule zdiv_mono2)
apply force
apply force
apply force
done

lemma div_ge: "[| (0::int) <= x; x <= y |] ==> x div (2::int) <= y"
apply (subgoal_tac "x div (2::int) <= x", simp)
apply (simp add: div_mono_gt0)
done

lemma div_gt: "[| (0::int) <= x; x < y |] ==> x div (2::int) < y"
apply (subgoal_tac "x div (2::int) <= x", simp)
apply (simp add: div_mono_gt0)
done

lemma divDec1: "(1::int) < x ==> (x div 2 <= x)"
apply (simp add: div_ge)
done

lemma insert4_r967: "([|((1::int) <= j);
(j < k);
(k <= (s + (1::int)));
(~(j = (i' div (2::int))));
((~(k = (i' div (2::int)))) | (~((i' div (2::int)) = (s + (1::int)))));
((1::int) < i');
((fieldRead (fieldWrite p n p1) (arrayRead c' (i' div (2::int)))) < p1);
((1::int) <= i');
(i' <= (s + (1::int)));
({x. (EX j. ((x = (arrayRead c j)) & (j <= s) & ((1::int) <= j)))} = {x. (EX j. ((x = (arrayRead c' j)) & (~(j = i')) & (j <= (s + (1::int))) & ((1::int) <= j)))});
(ALL j. (ALL k. ((((~(k = i')) | (~(i' = (s + (1::int))))) & (~(j = i')) & (k <= (s + (1::int))) & (j < k) & ((1::int) <= j)) --> (~((arrayRead c' j) = (arrayRead c' k))))));
(~(n : {x. (EX j. ((x = (arrayRead c j)) & (j <= s) & ((1::int) <= j)))}));
(~(n = nullObj));
((0::int) <= s);
(ALL i. (ALL j. (((j <= s) & (i < j) & ((1::int) <= i)) --> (~((arrayRead c i) = (arrayRead c j))))))|] ==>
    (~((arrayRead (arrayWrite c' i' (arrayRead c' (i' div (2::int)))) j) = (arrayRead (arrayWrite c' i' (arrayRead c' (i' div (2::int)))) k))))"
apply (case_tac "j ~= i'")
apply (case_tac "k ~= i'")
apply (simp add: array2_def)
apply (simp add: array1_def array2_def)
apply (case_tac "j < (i' div 2)")
apply (erule_tac x=j in allE)
apply (erule_tac x=j in allE)
apply (erule_tac x=j in allE)
apply (erule_tac x="i' div 2" in allE)
apply (case_tac "i' div 2 = i'")
apply force
apply (subgoal_tac "i' div 2 <= s + 1", simp)
apply (simp add: div_ge)
apply (erule_tac x="i' div 2" in allE)
apply (erule_tac x="i' div 2" in allE)
apply (erule_tac x="i' div 2" in allE)
apply (erule_tac x=j in allE)
apply (subgoal_tac "i' div 2 <= s + 1", simp)
apply (simp add: div_ge_1)
apply force
apply (simp add: div_ge)
apply (simp add: array1_def array2_def)
apply (case_tac "k < (i' div 2)")
apply (erule_tac x=k in allE)
apply (erule_tac x=k in allE)
apply (erule_tac x=k in allE)
apply (erule_tac x="i' div 2" in allE)
apply (subgoal_tac "i' div 2 <= s + 1", simp)
apply force
apply (simp add: div_ge)
apply (erule_tac x="i' div 2" in allE)
apply (erule_tac x="i' div 2" in allE)
apply (erule_tac x="i' div 2" in allE)
apply (erule_tac x=k in allE)
apply (subgoal_tac "i' div 2 <= s + 1", simp)
apply (subgoal_tac "i' div 2 < k", simp add: div_ge_1)
apply (simp add: div_gt)
apply (simp add: div_ge)
done

lemma insert5_r967: "([|((1::int) < i');
((fieldRead (fieldWrite p n p1) (arrayRead c' (i' div (2::int)))) < p1);
((1::int) <= i');
(i' <= (s + (1::int)));
({x. (EX j. ((x = (arrayRead c j)) & (j <= s) & ((1::int) <= j)))} = {x. (EX j. ((x = (arrayRead c' j)) & (~(j = i')) & (j <= (s + (1::int))) & ((1::int) <= j)))});
(ALL j. (ALL k. ((((~(k = i')) | (~(i' = (s + (1::int))))) & (~(j = i')) & (k <= (s + (1::int))) & (j < k) & ((1::int) <= j)) --> (~((arrayRead c' j) = (arrayRead c' k))))));
(~(n : {x. (EX j. ((x = (arrayRead c j)) & (j <= s) & ((1::int) <= j)))}));
(~(n = nullObj));
((0::int) <= s);
(ALL i. (ALL j. (((j <= s) & (i < j) & ((1::int) <= i)) --> (~((arrayRead c i) = (arrayRead c j))))))|] ==>
    ({x. (EX j. ((x = (arrayRead c j)) & (j <= s) & ((1::int) <= j)))} = {x. (EX j. ((x = (arrayRead (arrayWrite c' i' (arrayRead c' (i' div (2::int)))) j)) & (~(j = (i' div (2::int)))) & (j <= (s + (1::int))) & ((1::int) <= j)))}))"
apply auto
apply (case_tac "j ~= i' div 2")
apply (rule_tac x="j" in exI)
apply (simp add: array2_def)
apply (rule_tac x="i'" in exI)
apply (simp add: array1_def)
apply (case_tac "j ~= i'")
apply (rule_tac x="j" in exI)
apply (simp add: array2_def)
apply (rule_tac x="i' div 2" in exI)
apply (simp add: array1_def)
apply (subgoal_tac "i' div 2 <= i'")
apply simp
apply (simp add: div_ge_1)
apply (simp add: divDec1)
done

lemma insert6_r967: "([|((1::int) < i');
((fieldRead (fieldWrite p n p1) (arrayRead c' (i' div (2::int)))) < p1);
((1::int) <= i');
(i' <= (s + (1::int)));
({x. (EX j. ((x = (arrayRead c j)) & (j <= s) & ((1::int) <= j)))} = {x. (EX j. ((x = (arrayRead c' j)) & (~(j = i')) & (j <= (s + (1::int))) & ((1::int) <= j)))});
(ALL j. (ALL k. ((((~(k = i')) | (~(i' = (s + (1::int))))) & (~(j = i')) & (k <= (s + (1::int))) & (j < k) & ((1::int) <= j)) --> (~((arrayRead c' j) = (arrayRead c' k))))));
(~(n : {x. (EX j. ((x = (arrayRead c j)) & (j <= s) & ((1::int) <= j)))}));
(~(n = nullObj));
((0::int) <= s);
(ALL i. (ALL j. (((j <= s) & (i < j) & ((1::int) <= i)) --> (~((arrayRead c i) = (arrayRead c j))))))|] ==>
    ((i' div (2::int)) <= (s + (1::int))))"
apply (subgoal_tac "i' div 2 <= i'")
apply simp
apply (simp add: divDec1)
done

lemma insert7_r967: "([|((1::int) < i');
((fieldRead (fieldWrite p n p1) (arrayRead c' (i' div (2::int)))) < p1);
((1::int) <= i');
(i' <= (s + (1::int)));
({x. (EX j. ((x = (arrayRead c j)) & (j <= s) & ((1::int) <= j)))} = {x. (EX j. ((x = (arrayRead c' j)) & (~(j = i')) & (j <= (s + (1::int))) & ((1::int) <= j)))});
(ALL j. (ALL k. ((((~(k = i')) | (~(i' = (s + (1::int))))) & (~(j = i')) & (k <= (s + (1::int))) & (j < k) & ((1::int) <= j)) --> (~((arrayRead c' j) = (arrayRead c' k))))));
(~(n : {x. (EX j. ((x = (arrayRead c j)) & (j <= s) & ((1::int) <= j)))}));
(~(n = nullObj));
((0::int) <= s);
(ALL i. (ALL j. (((j <= s) & (i < j) & ((1::int) <= i)) --> (~((arrayRead c i) = (arrayRead c j))))))|] ==>
    ((1::int) <= (i' div (2::int))))"
apply (simp add: div_ge_1)
done

lemma insert8_r967: "([|(~(((fieldRead (fieldWrite p n p1) (arrayRead c' (i' div (2::int)))) < p1) & ((1::int) < i')));
((1::int) <= i');
(i' <= (s + (1::int)));
({x. (EX j. ((x = (arrayRead c j)) & (j <= s) & ((1::int) <= j)))} = {x. (EX j. ((x = (arrayRead c' j)) & (~(j = i')) & (j <= (s + (1::int))) & ((1::int) <= j)))});
(ALL j. (ALL k. ((((~(k = i')) | (~(i' = (s + (1::int))))) & (~(j = i')) & (k <= (s + (1::int))) & (j < k) & ((1::int) <= j)) --> (~((arrayRead c' j) = (arrayRead c' k))))));
(~(n : {x. (EX j. ((x = (arrayRead c j)) & (j <= s) & ((1::int) <= j)))}));
(~(n = nullObj));
((0::int) <= s);
(ALL i. (ALL j. (((j <= s) & (i < j) & ((1::int) <= i)) --> (~((arrayRead c i) = (arrayRead c j))))))|] ==>
    ({x. (EX j. ((x = (arrayRead (arrayWrite c' i' n) j)) & (j <= (s + (1::int))) & ((1::int) <= j)))} = ({x. (EX j. ((x = (arrayRead c j)) & (j <= s) & ((1::int) <= j)))} Un {n})))"
apply auto
apply (rule_tac x="j" in exI)
apply (case_tac "j = i'")
apply (simp add: array1_def)
apply (simp add: array2_def)
apply (rule_tac x="j" in exI)
apply (case_tac "j = i'")
apply (simp add: array1_def)
apply (simp add: array2_def)
apply (rule_tac x="i'" in exI)
apply (simp add: array1_def)
apply (rule_tac x="i'" in exI)
apply (simp add: array1_def)
apply (rule_tac x="j" in exI)
apply (simp add: array2_def)
apply (rule_tac x="j" in exI)
apply (simp add: array2_def)
done

lemma insert9_r967: "([|((1::int) <= i);
(i < j);
(j <= (s + (1::int)));
(~(((fieldRead (fieldWrite p n p1) (arrayRead c' (i' div (2::int)))) < p1) & ((1::int) < i')));
((1::int) <= i');
(i' <= (s + (1::int)));
({x. (EX j. ((x = (arrayRead c j)) & (j <= s) & ((1::int) <= j)))} = {x. (EX j. ((x = (arrayRead c' j)) & (~(j = i')) & (j <= (s + (1::int))) & ((1::int) <= j)))});
(ALL j. (ALL k. ((((~(k = i')) | (~(i' = (s + (1::int))))) & (~(j = i')) & (k <= (s + (1::int))) & (j < k) & ((1::int) <= j)) --> (~((arrayRead c' j) = (arrayRead c' k))))));
(~(n : {x. (EX j. ((x = (arrayRead c j)) & (j <= s) & ((1::int) <= j)))}));
(~(n = nullObj));
((0::int) <= s);
(ALL i. (ALL j. (((j <= s) & (i < j) & ((1::int) <= i)) --> (~((arrayRead c i) = (arrayRead c j))))))|] ==>
    (~((arrayRead (arrayWrite c' i' n) i) = (arrayRead (arrayWrite c' i' n) j))))"
apply (case_tac "j ~= i'")
apply (case_tac "i ~= i'")
apply (simp add: array2_def)
apply (simp add: array1_def array2_def)
apply (erule_tac x="i" in allE)
apply (erule_tac x="j" in allE)
apply force
apply (simp add: array1_def array2_def)
apply (erule_tac x="i" in allE)
apply (erule_tac x="i" in allE)
apply force
done

lemma swap0_r967: "([|((0::int) <= s);
(ALL i. (ALL j. (((j <= s) & (i < j) & ((1::int) <= i)) --> (~((arrayRead c i) = (arrayRead c j))))));
((1::int) <= a);
(a <= s);
((1::int) <= b);
(b <= s)|] ==>
    ({x. (EX j. ((x = (arrayRead (arrayWrite (arrayWrite c a (arrayRead c b)) b (arrayRead c a)) j)) & (j <= s) & ((1::int) <= j)))} = {x. (EX j. ((x = (arrayRead c j)) & (j <= s) & ((1::int) <= j)))}))"
apply auto
apply (case_tac "a ~= j & b ~= j")
apply (rule_tac x="j" in exI)
apply (simp add: array2_def)
apply (case_tac "a = j")
apply (rule_tac x="b" in exI)
apply (case_tac "a = b", simp add: array1_def)
apply (simp add: array1_def array2_def)
apply (case_tac "b = j")
apply (rule_tac x="a" in exI)
apply (simp add: array1_def array2_def)
apply force
apply (case_tac "a ~= j & b ~= j")
apply (rule_tac x="j" in exI)
apply (simp add: array2_def)
apply (case_tac "a = j")
apply (rule_tac x="b" in exI)
apply (case_tac "a = b", simp add: array1_def)
apply (simp add: array1_def array2_def)
apply (rule_tac x="a" in exI)
apply (case_tac "a = b")
apply (simp add: array1_def)
apply (simp add: array1_def array2_def)
done

lemma swap2_r967: "([|((0::int) <= s);
(ALL i. (ALL j. (((j <= s) & (i < j) & ((1::int) <= i)) --> (~((arrayRead c i) = (arrayRead c j))))));
((1::int) <= a);
(a <= s);
((1::int) <= b);
(b <= s)|] ==>
    ((arrayRead (arrayWrite (arrayWrite c a (arrayRead c b)) b (arrayRead c a)) a) = (arrayRead c b)))"
apply (case_tac "a = b")
apply (simp add: array1_def)
apply (simp add: array1_def array2_def)
done

lemma swap3_r967: "([|((1::int) <= i);
(i < j);
(j <= s);
((0::int) <= s);
(ALL i. (ALL j. (((j <= s) & (i < j) & ((1::int) <= i)) --> (~((arrayRead c i) = (arrayRead c j))))));
((1::int) <= a);
(a <= s);
((1::int) <= b);
(b <= s)|] ==>
    (~((arrayRead (arrayWrite (arrayWrite c a (arrayRead c b)) b (arrayRead c a)) i) = (arrayRead (arrayWrite (arrayWrite c a (arrayRead c b)) b (arrayRead c a)) j))))"
apply (case_tac "i = b")
apply (subgoal_tac "j ~= b", simp add: array1_def array2_def)
apply (case_tac "j = a", simp add: array1_def)
apply force
apply (simp add: array2_def)
apply (case_tac "a < j")
apply force
apply (subgoal_tac "j < a")
apply force
apply force
apply force
apply (case_tac "j = b", simp add: array1_def array2_def)
apply (case_tac "i = a", simp add: array1_def)
apply force
apply (simp add: array2_def)
apply (case_tac "i < a")
apply force
apply (subgoal_tac "a < i")
apply (erule_tac x=a in allE)
apply (erule_tac x=i in allE)
apply (subgoal_tac "i <= s")
apply force
apply force
apply force
apply (case_tac "i = a", simp add: array1_def array2_def)
apply (case_tac "b < j")
apply force
apply (subgoal_tac "j < b")
apply force
apply force
apply (case_tac "j = a", simp add: array1_def array2_def)
apply (case_tac "b < i")
apply (erule_tac x=b in allE)
apply (erule_tac x=i in allE)
apply (subgoal_tac "i <= s")
apply force
apply force
apply force
apply (simp add: array2_def)
done

lemma swap0_r991: "([|((1::int) <= a);
((1::int) <= b);
(b <= s);
(a <= s)|] ==>
    ({x. (EX j. (((1::int) <= j) & (x = (arrayRead (arrayWrite (arrayWrite c a (arrayRead c b)) b (arrayRead c a)) j)) & (j <= s)))} = {x. (EX j. (((1::int) <= j) & (x = (arrayRead c j)) & (j <= s)))}))"
apply auto
apply (case_tac "j = b", simp add: array1_def)
apply force
apply (simp add: array2_def)
apply (case_tac "j = a", simp add: array1_def)
apply force
apply (simp add: array2_def)
apply force
apply (case_tac "j = a")
apply (rule_tac x=b in exI, simp add: array1_def)
apply (case_tac "j = b")
apply (rule_tac x=a in exI, simp add: array1_def array2_def)
apply (rule_tac x=j in exI, simp add: array2_def)
done

lemma swap3_r991: "([|((1::int) <= a);
((1::int) <= b);
(b <= s);
(a <= s)|] ==>
    ((arrayRead (arrayWrite (arrayWrite c a (arrayRead c b)) b (arrayRead c a)) a) = (arrayRead c b)))"
apply (case_tac "a = b", simp add: array1_def)
apply (simp add: array1_def array2_def)
done

lemma bubbleDown8: "([|(j <= s);
(i__6 < j);
((1::int) <= i__6);
({x. (EX j. (((1::int) <= j) & ((j <= s) & (x = (arrayRead c'__2 j)))))} = {x. (EX j. (((1::int) <= j) & ((j <= s) & (x = (arrayRead c j)))))});
(ALL k. (((~(k = i)) & (~(k = ((i * (2::int)) + (1::int))))) --> ((arrayRead c'__2 k) = (arrayRead c k))));
((arrayRead c'__2 ((i * (2::int)) + (1::int))) = (arrayRead c i));
((arrayRead c'__2 i) = (arrayRead c ((i * (2::int)) + (1::int))));
(ALL i__5. (ALL j. ((((1::int) <= i__5) & ((i__5 < j) & (j <= s))) --> (~((arrayRead c i__5) = (arrayRead c j))))));
((0::int) <= s);
(~(((i * (2::int)) + (1::int)) = i));
((fieldRead p (arrayRead c (i * (2::int)))) < (fieldRead p (arrayRead c ((i * (2::int)) + (1::int)))));
(((i * (2::int)) + (1::int)) <= s);
((fieldRead p (arrayRead c i)) < (fieldRead p (arrayRead c (i * (2::int)))));
((i * (2::int)) <= s);
((1::int) <= i);
(i <= s);
(ALL i__3. (ALL j. ((((1::int) <= i__3) & ((i__3 < j) & (j <= s))) --> (~((arrayRead c i__3) = (arrayRead c j))))))|] ==>
    (~((arrayRead c'__2 i__6) = (arrayRead c'__2 j))))"
apply (case_tac "i__6 ~= i & i__6 ~= i * 2 + 1")
apply (case_tac "j ~= i & j ~= i * 2 + 1", simp)
apply (case_tac "j = i", simp)
apply (subgoal_tac "j = i * 2 + 1")
apply (case_tac "i__6 < i", simp)
apply (erule_tac x=i__6 in allE)
apply (erule_tac x=i in allE)
apply (erule_tac x=i__6 in allE)
apply force
apply simp
apply (erule_tac x=j in allE)
apply (case_tac "i__6 = i")
apply (case_tac "j = i * 2 + 1")
apply (erule_tac x=i in allE)
apply (erule_tac x="i * 2 + 1" in allE)
apply force
apply (case_tac "i * 2 + 1 < j", simp)
apply (erule_tac x=j in allE)
apply (erule_tac x="i * 2 + 1" in allE)
apply force
apply simp
done

lemma bubbleDown24: "([|(j <= s);
(i__12 < j);
((1::int) <= i__12);
({x. (EX j. (((1::int) <= j) & ((j <= s) & (x = (arrayRead c'__2 j)))))} = {x. (EX j. (((1::int) <= j) & ((j <= s) & (x = (arrayRead c j)))))});
(ALL k. (((~(k = i)) & (~(k = (i * (2::int))))) --> ((arrayRead c'__2 k) = (arrayRead c k))));
((arrayRead c'__2 (i * (2::int))) = (arrayRead c i));
((arrayRead c'__2 i) = (arrayRead c (i * (2::int))));
(ALL i__11. (ALL j. ((((1::int) <= i__11) & ((i__11 < j) & (j <= s))) --> (~((arrayRead c i__11) = (arrayRead c j))))));
((0::int) <= s);
(~((i * (2::int)) = i));
(~((((i * (2::int)) + (1::int)) <= s) & ((fieldRead p (arrayRead c (i * (2::int)))) < (fieldRead p (arrayRead c ((i * (2::int)) + (1::int)))))));
((fieldRead p (arrayRead c i)) < (fieldRead p (arrayRead c (i * (2::int)))));
((i * (2::int)) <= s);
((1::int) <= i);
(i <= s);
(ALL i__3. (ALL j. ((((1::int) <= i__3) & ((i__3 < j) & (j <= s))) --> (~((arrayRead c i__3) = (arrayRead c j))))))|] ==>
    (~((arrayRead c'__2 i__12) = (arrayRead c'__2 j))))"
apply (case_tac "i__12 ~= i & i__12 ~= i * 2")
apply (case_tac "j ~= i & j ~= i * 2", simp)
apply (case_tac "j = i", simp)
apply (subgoal_tac "j = i * 2")
apply (erule_tac x=i__12 in allE)
apply (case_tac "i__12 < i", simp)
apply (erule_tac x=i in allE)
apply (erule_tac x=i in allE)
apply (erule_tac x=i__12 in allE)
apply force
apply simp
apply (erule_tac x=j in allE)
apply (case_tac "i__12 = i")
apply (case_tac "j = i * 2")
apply (erule_tac x=i in allE)
apply (erule_tac x=i in allE)
apply (erule_tac x="i * 2" in allE)
apply force
apply (case_tac "j < i * 2")
apply force
apply (erule_tac x="i * 2" in allE)
apply (erule_tac x="i * 2" in allE)
apply (erule_tac x=j in allE, simp)
apply simp
done

lemma bubbleDown40: "([|(j <= s);
(i__18 < j);
((1::int) <= i__18);
({x. (EX j. (((1::int) <= j) & ((j <= s) & (x = (arrayRead c'__2 j)))))} = {x. (EX j. (((1::int) <= j) & ((j <= s) & (x = (arrayRead c j)))))});
(ALL k. (((~(k = i)) & (~(k = ((i * (2::int)) + (1::int))))) --> ((arrayRead c'__2 k) = (arrayRead c k))));
((arrayRead c'__2 ((i * (2::int)) + (1::int))) = (arrayRead c i));
((arrayRead c'__2 i) = (arrayRead c ((i * (2::int)) + (1::int))));
(ALL i__17. (ALL j. ((((1::int) <= i__17) & ((i__17 < j) & (j <= s))) --> (~((arrayRead c i__17) = (arrayRead c j))))));
((0::int) <= s);
(~(((i * (2::int)) + (1::int)) = i));
((fieldRead p (arrayRead c i)) < (fieldRead p (arrayRead c ((i * (2::int)) + (1::int)))));
(((i * (2::int)) + (1::int)) <= s);
(~(((i * (2::int)) <= s) & ((fieldRead p (arrayRead c i)) < (fieldRead p (arrayRead c (i * (2::int)))))));
((1::int) <= i);
(i <= s);
(ALL i__3. (ALL j. ((((1::int) <= i__3) & ((i__3 < j) & (j <= s))) --> (~((arrayRead c i__3) = (arrayRead c j))))))|] ==>
    (~((arrayRead c'__2 i__18) = (arrayRead c'__2 j))))"
apply (case_tac "i__18 ~= i & i__18 ~= i * 2 + 1 & j ~= i & j ~= i * 2 + 1", simp)
apply (case_tac "i__18 = i")
apply (erule_tac x=j in allE)
apply (case_tac "j = i * 2 + 1")
apply force
apply (case_tac "j < i * 2 + 1")
apply force
apply simp
apply (case_tac "i__18 = i * 2 + 1", simp)
apply (case_tac "j = i", simp)
apply (case_tac "i__18 < i", simp)
apply (erule_tac x=i__18 in allE)
apply (erule_tac x=i in allE)
apply (erule_tac x=i in allE)
apply (erule_tac x=i__18 in allE)
apply force
done

lemma extractMax2: "([|({x. (EX j. (((1::int) <= j) & ((j <= (s - (1::int))) & (x = (arrayRead c'__1 j)))))} = {x. (EX j. (((1::int) <= j) & ((j <= (s - (1::int))) & (x = (arrayRead (arrayWrite c (1::int) (arrayRead c s)) j)))))});
(~((s - (1::int)) = (0::int)));
(~({x. (EX j. (((1::int) <= j) & (x = (arrayRead c j)) & (j <= s)))} = {}));
((0::int) <= s);
(ALL i. (ALL j. ((((1::int) <= i) & ((i < j) & (j <= s))) --> (~((arrayRead c i) = (arrayRead c j))))))|] ==>
    ({x. (EX j. (((1::int) <= j) & ((j <= (s - (1::int))) & (x = (arrayRead c'__1 j)))))} = ({x. (EX j. (((1::int) <= j) & ((j <= s) & (x = (arrayRead c j)))))} - {x. (x = (arrayRead c (1::int)))})))"
apply auto
apply (case_tac "ja = 1")
apply (rule_tac x=s in exI)
apply (simp add: array1_def)
apply (simp add: array2_def)
apply force
apply (case_tac "ja = 1")
apply (simp add: array1_def)
apply force
apply (simp add: array2_def)
apply (subgoal_tac "1 < ja")
apply force
apply force
apply (case_tac "ja ~= 1 & ja ~= s")
apply (rule_tac x=ja in exI)
apply (simp add: array2_def)
apply force
apply (case_tac "ja = 1")
apply force
apply (rule_tac x=1 in exI)
apply (simp add: array1_def)
done

lemma extractMax6: "([|(~(~((s - (1::int)) = (0::int))));
(~({x. (EX j. (((1::int) <= j) & (x = (arrayRead c j)) & (j <= s)))} = {}));
((0::int) <= s);
(ALL i. (ALL j. ((((1::int) <= i) & ((i < j) & (j <= s))) --> (~((arrayRead c i) = (arrayRead c j))))))|] ==>
    ({x. (EX j. (((1::int) <= j) & (x = (arrayRead (arrayWrite c (1::int) (arrayRead c s)) j)) & (j <= (s - (1::int)))))} = ({x. (EX j. (((1::int) <= j) & (x = (arrayRead c j)) & (j <= s)))} - {x. (x = (arrayRead c (1::int)))})))"
apply auto
apply (case_tac "ja ~= 1 & ja ~= s", simp)
apply (case_tac "ja = 1", simp)
apply (case_tac "ja = s", simp)
apply force
done

lemma bubbleDown_5: "[|
((arrayRead c' i) = (arrayRead c ((i * (2::int)) + (1::int))));
((arrayRead c' ((i * (2::int)) + (1::int))) = (arrayRead c i));
(ALL k. (((~(k = ((i * (2::int)) + (1::int)))) & (~(k = i))) --> ((arrayRead c' k) = (arrayRead c k))));
(~(((i * (2::int)) + (1::int)) = i));
(((i * (2::int)) + (1::int)) <= s);
((fieldRead p (arrayRead c (i * (2::int)))) < (fieldRead p (arrayRead c ((i * (2::int)) + (1::int)))));
((i * (2::int)) <= s);
((fieldRead p (arrayRead c i)) < (fieldRead p (arrayRead c (i * (2::int)))));
((1::int) <= i);
((0::int) <= s)|] ==>
({x. (EX j. ((x = (arrayRead c' j)) & (j <= s) & ((1::int) <= j)))} = {x. (EX j. ((x = (arrayRead c j)) & (j <= s) & ((1::int) <= j)))})"
apply auto
apply (case_tac "j ~= i * 2 + 1 & j ~= i")
apply (rule_tac x="j" in exI)
apply simp
apply (case_tac "j = i")
apply (rule_tac x="i * 2 + 1" in exI)
apply simp
apply (rule_tac x="i" in exI)
apply simp
apply (case_tac "j ~= i * 2 + 1 & j ~= i")
apply (rule_tac x="j" in exI)
apply simp
apply (case_tac "j = i")
apply (rule_tac x="i * 2 + 1" in exI)
apply simp
apply (rule_tac x="i" in exI)
apply simp
done

lemma bubbleDown_17: "[|
((arrayRead c' i) = (arrayRead c (i * (2::int))));
((arrayRead c' (i * (2::int))) = (arrayRead c i));
(ALL k. (((~(k = (i * (2::int)))) & (~(k = i))) --> ((arrayRead c' k) = (arrayRead c k))));
(~((i * (2::int)) = i));
(~(((fieldRead p (arrayRead c (i * (2::int)))) < (fieldRead p (arrayRead c ((i * (2::int)) + (1::int))))) & (((i * (2::int)) + (1::int)) <= s)));
((i * (2::int)) <= s);
((fieldRead p (arrayRead c i)) < (fieldRead p (arrayRead c (i * (2::int)))));
((1::int) <= i);
((0::int) <= s)|] ==>
({x. (EX j. ((x = (arrayRead c' j)) & (j <= s) & ((1::int) <= j)))} = {x. (EX j. ((x = (arrayRead c j)) & (j <= s) & ((1::int) <= j)))})"
apply auto
apply (case_tac "j ~= i * 2 & j ~= i")
apply (rule_tac x="j" in exI)
apply simp
apply (case_tac "j = i")
apply (rule_tac x="i * 2" in exI)
apply simp
apply (rule_tac x="i" in exI)
apply simp
apply (case_tac "j ~= i * 2 & j ~= i")
apply (rule_tac x="j" in exI)
apply simp
apply (case_tac "j = i")
apply (rule_tac x="i * 2" in exI)
apply simp
apply (rule_tac x="i" in exI)
apply simp
apply (case_tac "j ~= i * 2 & j ~= i")
apply (rule_tac x="j" in exI)
apply simp
apply (case_tac "j = i")
apply (rule_tac x="i * 2" in exI)
apply simp
apply (rule_tac x="i" in exI)
apply simp
apply (case_tac "j ~= i * 2 & j ~= i")
apply (rule_tac x="j" in exI)
apply simp
apply (case_tac "j = i")
apply (rule_tac x="i * 2" in exI)
apply simp
apply (rule_tac x="i" in exI)
apply simp
done

lemma bubbleDown_29: "[|
((arrayRead c' i) = (arrayRead c ((i * (2::int)) + (1::int))));
((arrayRead c' ((i * (2::int)) + (1::int))) = (arrayRead c i));
(ALL k. (((~(k = ((i * (2::int)) + (1::int)))) & (~(k = i))) --> ((arrayRead c' k) = (arrayRead c k))));
(~(((i * (2::int)) + (1::int)) = i));
(((i * (2::int)) + (1::int)) <= s);
((fieldRead p (arrayRead c i)) < (fieldRead p (arrayRead c ((i * (2::int)) + (1::int)))));
(~(((fieldRead p (arrayRead c i)) < (fieldRead p (arrayRead c (i * (2::int))))) & ((i * (2::int)) <= s)));
((1::int) <= i);
((0::int) <= s)|] ==>
({x. (EX j. ((x = (arrayRead c' j)) & (j <= s) & ((1::int) <= j)))} = {x. (EX j. ((x = (arrayRead c j)) & (j <= s) & ((1::int) <= j)))})"
apply auto
apply (case_tac "j ~= i * 2 + 1 & j ~= i")
apply (rule_tac x="j" in exI)
apply simp
apply (case_tac "j = i")
apply (rule_tac x="i * 2 + 1" in exI)
apply simp
apply (rule_tac x="i" in exI)
apply simp
apply (case_tac "j ~= i * 2 + 1 & j ~= i")
apply (rule_tac x="j" in exI)
apply simp
apply (case_tac "j = i")
apply (rule_tac x="i * 2 + 1" in exI)
apply simp
apply (rule_tac x="i" in exI)
apply simp
done

end