spec module CTAS {

  format Socket;

  proc openSockets()
    requires card(Weather.Data)=0 & card(Track.Data)=0 & card(GUI.Data)=0 & card(RouteAnalyzer.Data)=0 &
             card(Sockets.Open)=0 & card(Sockets.Readable)=0 & card(Sockets.Writable)=0
    modifies Weather.Data, Track.Data, GUI.Data, RouteAnalyzer.Data, 
             Sockets.Open, Sockets.Readable, Sockets.Writable, Sockets.OpenReadableWritable
    calls Weather, Sockets, Track, GUI, RouteAnalyzer
    ensures card(Weather.Data')=1 & card(Track.Data')=1 & 
            card(GUI.Data')=1 & card(RouteAnalyzer.Data')=1 &
            (Sockets.Open' = Sockets.Open + Weather.Data' + Track.Data' + GUI.Data' + RouteAnalyzer.Data') &
            (Sockets.Readable' = Sockets.Readable + Weather.Data' + Track.Data' + RouteAnalyzer.Data') &
            (Sockets.Writable' = Sockets.Writable + GUI.Data' + RouteAnalyzer.Data');

  proc readWeather() 
    requires card(Weather.Data)=1 & 
             (Weather.Data in Sockets.Open) & 
             (Weather.Data in Sockets.Readable)
    ensures true;

  proc readTrack()
    requires card(Track.Data)=1 & 
             (Track.Data in Sockets.Open) & (Track.Data in Sockets.Readable)
    ensures true;

  proc guiAction()
    requires card(GUI.Data)=1 &
             (GUI.Data in Sockets.Open) & (GUI.Data in Sockets.Writable)
    ensures true;

  proc sendToRouteAnalyzer()
    requires card(RouteAnalyzer.Data)=1 &
             (RouteAnalyzer.Data in Sockets.Open) & (RouteAnalyzer.Data in Sockets.Writable)
    ensures true;

  proc getFromRouteAnalyzer()
    requires card(RouteAnalyzer.Data)=1 &
             (RouteAnalyzer.Data in Sockets.Open) & (RouteAnalyzer.Data in Sockets.Readable)
    ensures true;

  proc run()
    requires card(Weather.Data)=0 & card(Track.Data)=0 & card(GUI.Data)=0 & card(RouteAnalyzer.Data)=0 &
             card(Sockets.Open)=0 & card(Sockets.Readable)=0 & card(Sockets.Writable)=0
    modifies Weather.Data, Track.Data, GUI.Data, RouteAnalyzer.Data, 
             Sockets.Open, Sockets.Readable, Sockets.Writable, Sockets.OpenReadableWritable
    ensures true;

}
