spec module DLL {
   format Entry;
   specvar Content : Entry set;

   proc addLast(p : Entry)
     requires not (p in Content) & (card(p) >= 1)
     modifies Content
     ensures Content' = Content + p;

   proc getFirst() returns e: Entry
     requires card(Content) >= 1
     ensures (Content' = Content) & (e' in Content);

   proc remove(e : Entry)
     requires (e in Content) & card(e) = 1
     modifies Content
     ensures Content' = Content - e;

   proc contains(e : Entry) returns b : bool
     requires card(e) = 1
     ensures b' <=> (e' in Content);

   proc removeFirst() returns n:Entry
     requires card(Content)>=1
     modifies Content
     ensures card(n')=1 & (Content' = Content - n') & (n' in Content);

   proc isEmpty() returns rv:bool
     ensures rv' <=> (card(Content) = 0);

   proc clear() requires card(Content) >= 1
     modifies Content
     ensures card(Content') = 0;
}
