spec module Partition {

  format Elem;

  specvar S : Elem set;
  specvar A : Elem set;
  specvar B : Elem set;

  invariant disjoint(A,B) & (S = A + B);

  proc add(e : Elem)
    requires card(e)=1 & (not (e in S))
    modifies S, A, B
    ensures  (S' = S + e);

  proc remove(e : Elem)
    requires card(e) = 1 & (e in S)
    modifies S, A, B
    ensures (S' = S - e);
}
