spec module Skiplist {
    format Entry;
    specvar S : Entry set;

    proc getValue(e:Entry) returns v:int
      requires card(e)=1
      ensures true;

    proc setValue(e:Entry; v:int)
      requires card(e)=1 & not (e in S)
      ensures true;

    proc lookup(v:int) returns e:Entry
      ensures card(e')>=1 => (e' in S);

    proc add(e:Entry)
      requires card(e) = 1 & not (e in S)
      modifies S
      ensures S' = S + e';

    // debugging functions that don't use the nextSub fields
    proc lookupSlow(v:int) returns e:Entry
      ensures card(e')=0 | (e' in S);
    proc addFront(e:Entry)
      requires card(e) = 1 & not (e in S)
      modifies S
      ensures S' = S + e;
}
