spec module List {
   format Entry;
   specvar Content : Entry set;

   proc add(e : Entry)
     requires not (e in Content)
     modifies Content
     ensures Content' = Content + e;

   proc removeFirst() returns f : Entry
     requires card(Content)>=1
     modifies Content
     ensures (Content' = Content - f) & card(f)=1 & (f in Content);

   proc remove(e : Entry)
     requires (e in Content) & card(e)=1
     modifies Content
     ensures Content' = Content - e;

   proc getFirst() returns e: Entry
     requires card(Content) >= 1
     ensures (e in Content) & (Content' = Content - e);

   proc isEmpty() returns b : bool 
     ensures b <=> (card(Content)=0);
}
