spec module Scheduler 
{
    format Process;
    specvar Running, Suspended : Process set;

    proc suspend(p : Process; priority : int)
        requires (p in Running) & card(p)=1
        modifies Running, Suspended, RunningList.InList, SuspendedQueue.InQueue
        calls RunningList, SuspendedQueue
        ensures (Suspended' = Suspended + p) &
                (Running' = Running - p);

    proc hasSuspended() returns b : bool
        calls SuspendedQueue
        ensures b' <=> (Suspended != {});

    proc wakeUpFirst()
         requires (Suspended != {})
         modifies Running, Suspended, RunningList.InList, SuspendedQueue.InQueue
         calls SuspendedQueue, RunningList 
         ensures exists r : Process.
                 ((r in Suspended) &
                 (Suspended' = Suspended - r)  &
                 (Running' = Running + r));
}
