spec module ArraySet {
    format Node;

    specvar setInit : bool;
    specvar S : Node set;

    proc init() requires true ensures setInit;
    proc add(e:Node) requires setInit & card(e) = 1
                     modifies S
                     ensures setInit & (S' = S + e);

    proc remove(e:Node) requires setInit & card(e) = 1
                        modifies S
                        ensures setInit & (S' = S - e);

    proc contains(e:Node) returns b : bool
                          requires setInit & card(e) = 1
                          ensures b <=> (e in S);

    proc get(c:int) returns e:Node 
                    requires setInit
                    ensures card(e) = 0 | (e in S);
}
