spec module DLLIter {
  format Node;
  specvar setInit : bool;
  specvar Content : Node set;
  specvar Iter : Node set;

  default I(f) = f & setInit;

  proc init() suspends I modifies setInit ensures setInit';


  proc isEmpty() returns e:bool 
    ensures not e <=> (card(Content') >= 1);

  proc add(n : Node)
    requires card(n)=1 & not (n in Content)
    modifies Content
    ensures (Content' = Content + n);

  proc remove(n : Node)
    requires card(n)=1 & (n in Content)
    modifies Content, Iter
    ensures (Content' = Content - n) &
            (Iter' = Iter - n) & (Iter' in Content');

  proc openIter()
    requires card(Iter) = 0
    modifies Iter
    ensures (Iter' = Content);

  proc nextIter() returns n : Node
    requires card(Iter)>=1
    modifies Iter
    ensures card(n')=1 & (n' in Iter) & 
            (Iter' = Iter - n') & (Iter in Content);

  proc isLastIter() returns e:bool 
    ensures not e <=> (card(Iter') >= 1);

  proc closeIter()
    modifies Iter
    ensures card(Iter') = 0;
}
