spec module DLLIter {
  format Node;
  specvar Content : Node set;
  specvar Iter : Node set;

  predicate @inv() = Iter in Content;

  proc add(n : Node)
    requires @inv() & card(n)=1 & not (n in Content)
    modifies Content
    ensures (Content' = Content + n) & @inv'();

  proc remove(n : Node)
    requires card(n)=1 & (n in Content) &
             @inv()
    modifies Content, Iter
    ensures (Content' = Content - n) &
            (Iter' = Iter - n) &
            @inv'();

  proc initIter()
    requires true
    modifies Iter
    ensures (Iter' = Content) & @inv'();

  proc nextIter() returns n : Node
    requires card(Iter)>=1 & @inv()
    modifies Iter
    ensures card(n')=1 & (n' in Iter) & 
            (Iter' = Iter - n') & 
            @inv'();
}
