spec module DLLQueue {
   format Entry;
   specvar Content : Entry set;

   proc addLast(p : Entry)
     requires not (p in Content)
     modifies Content
     ensures Content' = Content + p;

   proc removeFirst() returns f : Entry
     requires card(Content)>=1
     modifies Content
     ensures card(Content) = 0 | ((Content' = Content - f) & card(f)=1 & (f in Content));

   proc getFirst() returns e: Entry
     requires card(Content) >= 1
     ensures (e in Content) & (card(Content) >= 1 => card(e) = 1);

   proc isEmpty() returns b : bool 
     ensures not b' <=> (card(Content') >= 1);
}
