spec module DLLSet {
   format Entry;
   specvar Content : Entry set;

   proc add(e : Entry)
     requires not (e in Content)
     modifies Content
     ensures Content' = Content + e;

   proc removeFirst() returns f : Entry
     requires card(Content)>=1
     modifies Content
     ensures (Content' = Content - f') & card(f')=1 & (f' in Content);

   proc remove(e : Entry)
     requires (e in Content) & card(e)=1
     modifies Content
     ensures Content' = Content - e;

   proc getFirst() returns e: Entry
     requires card(Content) >= 1
     ensures (e' in Content) & (card(Content) >= 1 => card(e') = 1);

   proc isEmpty() returns b : bool 
     ensures not b' <=> (card(Content') >= 1);
}
