spec module DLLStack {
    format Entry;

    proc add(e:Entry) 
         requires card(e) = 1 & (not (e in DLLSet.Content))
         modifies DLLSet.Content
         calls DLLSet
         ensures (DLLSet.Content' = DLLSet.Content + e);

    proc removeFirst() returns e:Entry
         requires card(DLLSet.Content) >= 1
         modifies DLLSet.Content
         calls DLLSet
         ensures card(DLLSet.Content) = 0 |
                 (exists e:Entry. (DLLSet.Content' = DLLSet.Content - e') &
                                   card(e') = 1);

    proc getFirst() returns e:Entry
         requires card(DLLSet.Content) >= 1
         calls DLLSet
         ensures (e' in DLLSet.Content) & 
                 (card(DLLSet.Content) >= 1 => card(e') = 1);

    proc isEmpty() returns rv:bool
         calls DLLSet
         ensures rv' <=> card(DLLSet.Content') = 0;
}
