// Implements a non-circular, no head, no tail, singly-linked list
// Provides a set interface.

spec module SLLSet {
    format Entry;

    specvar S : Entry set;

    proc add(e:Entry) requires card(e) = 1 & (not (e in S))
                     modifies S
                     ensures (S' = S + e);

    proc remove(e:Entry) requires card(e) = 1 & (e in S)
                         modifies S
                         ensures (S' = S - e);

    proc contains(e:Entry) returns b : bool
                          requires card(e) = 1
                          ensures b' <=> (e in S);

    proc getFirst() returns e:Entry 
                    requires true
                    ensures e' in S;

    /*proc reverse() requires true ensures true;*/
}
