spec module SLLStack {
    format Entry;

    specvar S : Entry set;

    proc add(e:Entry) requires card(e) = 1 & (not (e in S))
                     modifies S
                     ensures (S' = S + e);

    proc removeFirst() returns e:Entry
                       requires card(S) >= 1
                       modifies S
                       ensures (S' = S - e') & card(e') = 1;

    proc getFirst() returns e:Entry 
                    requires true
                    ensures (e' in S) & (card(S) >= 1 => card(e') = 1);

    proc isEmpty() returns rv:bool
                   ensures rv' <=> card(S') = 0;
}
