spec module SLLTSet {
    format Entry;

    sets S : Entry;

    proc add(e:Entry) requires card(e) = 1 & (not (e in S))
                     modifies S
                     ensures (S' = S + e);

    proc remove(e:Entry) requires card(e) = 1 & (e in S)
                         modifies S
                         ensures (S' = S - e);

    proc contains(e:Entry) returns b : bool
                          requires card(e) = 1
                          ensures b <=> (e in S);

    proc getFirst() returns e:Entry 
                    requires true
                    ensures e in S;

    proc getLast() returns e : Entry
                   requires true
                   ensures e in S;
}
