spec module HDLLIter {
  format Node;

  specvar init : bool;
  specvar Content : Node set;
  specvar Iter : Node set;

  predicate @inv() = Iter in Content;

  proc init()
    requires not init
    modifies init
    ensures card(Content)=0 & init';

  proc add(n : Node)
    requires init & @inv() & card(n)=1 & not (n in Content)
    modifies Content
    ensures (Content' = Content + n) & @inv'();

  proc remove(n : Node)
    requires init & card(n)=1 & (n in Content) &
             @inv()
    modifies Content, Iter
    ensures (Content' = Content - n) &
            (Iter' = Iter - n) &
            @inv'();

  proc initIter()
    requires init
    modifies Iter
    ensures (Iter' = Content) & @inv'();

  proc nextIter() returns n : Node
    requires init & card(Iter)>=1 & @inv()
    modifies Iter
    ensures card(n)=1 & (n in Iter) & 
            (Iter' = Iter - n) & 
            @inv'();
}
