spec module ExposedList = List with Entry <- Cell;
spec module UnexposedList = List with Entry <- Cell;

spec module EstablishInvariants
{
    format Cell;
    specvar MarkedCells, MinedCells, ExposedCells, UnexposedCells, U : Cell set;
    specvar gameOver : bool;

    predicate @repinv() = (ExposedCells = ExposedList.InList) &
                          (UnexposedCells = UnexposedList.InList);

    // constructor
    proc init(size:int; mineCount:int) 
        requires card(ExposedCells)=0 & card(UnexposedCells) = 0 &
                 card(ExposedList.InList)=0 & card(UnexposedList.InList)=0 &
                 card(U)=0 & disjoint(MarkedCells, ExposedCells)
        modifies U, UnexposedCells, UnexposedList.InList, MinedCells
        ensures @repinv'() & card(ExposedCells) = 0 & disjoint(MarkedCells, ExposedCells);

}
