spec module DLLIter {
  format Node;
  specvar Content : Node set;
  specvar Iter : Node set;

  invariant Iter in Content;

  proc add(n : Node)
    requires card(n)=1 & not (n in Content)
    modifies Content
    ensures (Content' = Content + n);

  proc remove(n : Node)
    requires card(n)=1 & (n in Content)
    modifies Content, Iter
    ensures (Content' = Content - n) &
            (Iter' = Iter - n);

  proc contains(n:Node) returns rv:bool
    ensures rv' <=> (n in Content);

  proc initIter()
    modifies Iter
    ensures (Iter' = Content);

  proc nextIter() returns n : Node
    requires (card(Iter) >= 1)
    modifies Iter
    ensures card(n')=1 & 
	(n' in Iter) & (Iter' = Iter - n');

  proc lastIter() returns e : bool
    ensures (not e' <=> (card(Iter') >= 1));
}
