spec module Available = DLLIter with Node <- Pattern;
spec module Selected = DLLIter with Node <- Pattern;

spec module Patterns
{
    //specvar AvailableIter : Pattern set;
    //specvar AvailableContent : Pattern set;
    //specvar Selected : Pattern set;

    invariant Available.Iter in Available.Content;

    proc openAvailableIter() 
        modifies Available.Iter
        ensures Available.Iter' = Available.Content;
    proc hasAvailableNext() returns rv:bool 
        ensures rv' <=> card(Available.Iter') >= 1;
    proc getAvailableNext() returns n:Pattern 
        requires card(Available.Iter) >= 1
        modifies Available.Iter
        ensures card(n') = 1 & (n' in Available.Iter) & 
                (Available.Iter' = Available.Iter - n') &
                (Available.Iter' in Available.Content');

    proc addSelected (p:Pattern) 
        requires /*not (p in Selected.Content) &*/ card(p) = 1
        modifies Selected.Content
        ensures Selected.Content' = Selected.Content + p;

    // specs here not relevant for this example
    proc openPatternEltIter(p:Pattern) ensures true;
    proc hasPatternEltNext() returns rv:bool ensures true;
    proc getPatternEltNext() returns pr:Pair ensures true;

    proc getKey(pr:Pair) returns k:Value 
        ensures card(k') >= 1 & (k' in Strings.Canonical);
    proc getValueList(pr:Pair) returns vl:ValueList ensures true;
    proc getPatternElt(target:Pattern; k:Value) returns pr:Pair ensures true;
}
