spec module Hashmap
{
    format Hashmap;
    format Value;
    format Key;

    sets InHashMap : Hashmap * Key * Value;

    invariant "functional(InHashMap)";

    /* Initializes the hasmap with numBuckets buckets. */
    proc init(hm: Hashmap; numBuckets: int)
        requires 0 < numBuckets
	calls ListHT
	ensures true;

    proc put(hm: Hashmap; key: Key; val: Value) returns v: Value
	modifies InHashMap
	calls ListHT
	ensures ((v ~= nullObj) --> ((hm, key, v) in InHashMap)) &
	        ((hm, key, val) in InHashMap');

    proc containsKey(hm: Hashmap; key: Key) returns b: bool
        calls ListHT
        ensures b <=> (exists v. ((hm, key, v) in InHashMap));

    proc get(hm: Hashmap; key: Key) returns v: Value
        requires (exists val. ((hm, key, val) in InHashMap))
	calls ListHT
	ensures (hm, key, v) in InHashMap;
    
    proc remove(hm: Hashmap; key: Key) returns v: Value
	calls ListHT
	ensures ((v ~= nullObj) --> ((hm, key, v) in InHashMap)) &
                (not (exists val. ((hm, key, val) in InHashMap')))

    proc isEmpty(hm: Hashmap) returns b: bool
	calls ListHT
	ensures b <=> (InHashMap(hm) = {});
}
