spec module Hashtable
{
    format Hashtable;
    format Entry;
    specvar InHashTable : (Hashtable * Entry) set;

    proc init(ht: Hashtable; numBuckets: int)
        requires 0 < numBuckets
        modifies InHashTable
        calls ListHT
        ensures true;

    proc add(ht: Hashtable; e: Entry) returns b: bool
        modifies InHashTable
        calls ListHT
        ensures (b <=> ((ht, e) in InHashTable)) &
                (InHashTable' = InHashTable + (ht, e));

    proc contains(ht: Hashtable; e: Entry) returns b: bool
        calls ListHT
        ensures (e in InHashTable) <=> b;
    
    proc remove(ht: Hashtable; e: Entry) returns b: bool
        modifies InHashTable
        calls ListHT
        ensures (b <=> ((ht, e) in InHashTable)) &
                (InHashTable' = InHashTable - (ht, e));

    proc isEmpty(ht: Hashtable) returns b: bool
        calls ListHT
        ensures b <=> (InHashTable(ht) = {});
}
