spec module ListHM
{
  format List;
  format Key;
  format Value;
  sets Content : List * Key * Value;

  invariant "forall l k. (card(Content(l,k)) = 0 | card(Content(l,k)) = 1)";

  proc put(l: List; k: Key; v: Value) returns o: Value
    modifies Content(l)
    ensures Content'(l) = Content(l) + (k, v);

  proc containsKey(l: List; k: Key) returns b: bool
    ensures b <=> (exists v. ((l, k, v) in Content));

  proc getValue(l: List; k: Key) returns v: Value
    ensures (v ~= nullObj) --> ((l, k, v) in Content);

  proc removeKey(l: List; k: Key) returns v: Value
    modifies Content(l)
    ensures (v ~= nullObj) --> (Content'(l) = Content(l) - (k, v));

  proc isEmpty(l: List) returns b : bool
    ensures b <=> (Content(l) = {});
}
