spec module ListHT
{
   format List;
   format Entry;
   sets Content : List * Entry;

   invariant "functional(Content)";

   proc contains(l: List; e: Entry) returns b: bool
       ensures b <=> ((l, e) in Content); 

   proc add(l: List; e: Entry)
       requires not ((l, e) in Content)
       modifies Content(l)
       ensures Content' = Content + (l, e);

   proc remove(l: List; e: Entry)
       requires ((l, e) in Content)
       modifies Content(l)
       ensures Content' = Content - (l,e);

   proc isEmpty(l: List) returns b : bool
       ensures b <=> (Content(l) = {});
}
