spec module Set {
  /* A mutable instantiatable set of type S with elements of type E */

  format S;
  format E;

  specvar content : (S * E) set;

  proc insert(s:S; e:E)
    requires "true"
    modifies content
    ensures "content = old(content) \<union> {(s,e)}";

  proc remove(s:S; e:E)
    requires "true"
    modifies content
    ensures "content = old(content) - {(s,e)}";

  proc member(s:S; e:E) returns isMember:bool
    requires "true"
    ensures "isMember = ((s,e) \<in> content)";

  proc getMember(s:S) returns e:E
    requires "S \<noteq> {}"
    ensures "e \<in> S";

  proc clone(s:S) returns s1:S
    requires "true"
    modifies content, S
    ensures "s1 \<notin> old(S) &
             content = old(content) \<union> 
                       {(s1,e)|e. (s,e) \<in> old(content)}";

}
