spec module ASet = Set with E->A;
spec module BSet = Set with E->B;

spec module SRelation {
  /* A mutable static relation between A and B */

  format A;
  format B;

  specvar r : (A * B) set;

  proc insert(a:A; b:B)
    requires "true"
    modifies r
    ensures "r = old(r) \<union> {(a,b)}";

  proc remove(a:A; b:B)
    requires "true"
    modifies r
    ensures "r = old(r) - {(a,b)}";

  proc member(a:A; b:B) returns isMember:bool
    requires "true"
    ensures "isMember = ((a,b) \<in> r)";

  proc aRelated(a:A) returns bs:BSet.S
    requires "true"
    modifies BSet.content, BSet.S
    ensures "BSet.S = old(BSet.S) \<union> bs &
             BSet.content = BSet.content \<union>
                            {(bs,b)|b. (a,b) \<in> r}"

  proc bRelated(b:B) returns as:ASet.S
    requires "true"
    modifies ASet.content, ASet.S
    ensures "ASet.S = old(ASet.S) \<union> as &
             ASet.content = ASet.content \<union>
                            {(as,a)|a. (a,b) \<in> r}"

}
