spec module HostList = HDLLIter with Node <- Host;

spec module Config {
    specvar ready:bool;

    default I : pre(not proc *.init() && not proc HostList.add()) = ready;
    default S = card(StringTokenizer.S) = 0;
    proc init(argv:string[]) suspends I requires not ready 
      modifies StringTokenizer.S, Mimetypes.init, ready
      ensures ready';
    private proc processConfigFile(name:string) requires card(StringTokenizer.S) = 0 & ready 
      modifies StringTokenizer.S, Mimetypes.init 
      ensures card(StringTokenizer.S') = 0;
    proc getPort() returns p:int ensures true;
    proc getAccessLogFile() returns fn:string ensures true;
    proc getErrorLogFile() returns fn:string ensures true;
    proc setTypesConfig(s:string) 
      modifies StringTokenizer.S, Mimetypes.init 
      ensures card(StringTokenizer.S') = 0;
    private proc typesConfigLine(line:string) suspends S 
      requires ready & card(StringTokenizer.S) = 0 
      modifies StringTokenizer.S, Mimetypes.init 
      ensures card(StringTokenizer.S') = 0;
    private proc parseLine(line:string) 
      modifies StringTokenizer.S, Mimetypes.init 
      ensures card(StringTokenizer.S') = 0;
    private proc setPort(p:int) ensures true;
    private proc setServerName(s:string) ensures true;
    private proc setServerRoot(s:string) ensures true;
    private proc setDocumentRoot(s:string) ensures true;
    proc setCustomLog(s:string) ensures true;
    private proc setErrorLogFile(s:string) ensures true;
    private proc setAccessLogFile(s:string) ensures true;
}

scope Config
{
    modules Config, HostList, Host;
    exports Config;
    invariant (Config.ready <=> HostList.init) & 
              (Config.ready <=> card(HostList.Content) >= 1);
}