spec module HTTPRequest {
    specvar init:bool;
    // header fields
    specvar Entity:Entry set; 
    specvar Request:Entry set; 
    specvar General:Entry set;
    specvar Headers:Entry set;

    default I = init;

    proc slurpHeader(ic:in_channel) returns ok:bool suspends I
        modifies init
        ensures ok' => init';
    proc clean() suspends I
        modifies init
        ensures not init';
    proc getCmd() returns rv:string ensures true;
    proc getURI() returns rv:string ensures true;
    proc getVer() returns rv:string ensures true;
    proc getModTime() returns rv:string ensures true;
    proc getSimple() returns b:bool ensures true;
    proc getHeadOnly() returns b:bool ensures true;
    proc getGeneralValue(k:string) returns v:string calls HeaderEntry 
        ensures true;
    proc getRequestValue(k:string) returns v:string calls HeaderEntry 
        ensures true;
    proc getEntityValue(k:string) returns v:string  calls HeaderEntry
        ensures true;
}
