spec module HTTPRequest {
    specvar init:bool; specvar ready:bool;
    default R = ready;
    default I = init;

    proc prep() suspends R, I
        requires not HTTPReqGeneralHeader.init & 
                 not HTTPReqEntityHeader.init & not HTTPReqRequestHeader.init
        modifies ready,
                 HTTPReqGeneralHeader.init, HTTPReqRequestHeader.init, 
                 HTTPReqEntityHeader.init, HTTPReqGeneralHeader.Content,
		 HTTPReqRequestHeader.Content, HTTPReqEntityHeader.Content,
                 HTTPReqGeneralHeader.Iter,
		 HTTPReqRequestHeader.Iter, HTTPReqEntityHeader.Iter
        calls HTTPReqGeneralHeader, 
                 HTTPReqRequestHeader, HTTPReqEntityHeader 
        ensures ready';

    proc getGeneralRequestValue(k:key) returns v:string modifies HTTPReqGeneralHeader.Iter calls HTTPReqGeneralHeader, HeaderEntry ensures true;
    proc getRequestRequestValue(k:key) returns v:string modifies HTTPReqRequestHeader.Iter calls HTTPReqRequestHeader, HeaderEntry ensures true;
    proc getEntityRequestValue(k:key) returns v:string modifies HTTPReqEntityHeader.Iter calls HTTPReqEntityHeader, HeaderEntry ensures true;
}

spec module HTTPReqGeneralHeader = HDLLIter with Node <- Entry;
spec module HTTPReqRequestHeader = HDLLIter with Node <- Entry;
spec module HTTPReqEntityHeader = HDLLIter with Node <- Entry;
