spec module ExposedList = Arrayset with Node <- Cell;
spec module UnexposedList = List with Node <- Cell;

spec module EstablishInvariants
{
    format Cell;
    specvar MarkedCells, MinedCells, ExposedCells, UnexposedCells, U : Cell set;
    specvar gameOver, init, peeking : bool;

    invariant (ExposedCells = ExposedList.Content) &
              (UnexposedCells = UnexposedList.Content) &
              (init => ExposedList.setInit) &
              (peeking | (card(UnexposedList.Iter) = 0));

    // constructor
    proc init(size:int; mineCount:int) 
      requires card(ExposedCells)=0 & card(UnexposedCells) = 0 &
               card(ExposedList.Content)=0 & card(UnexposedList.Content)=0 &
               card(U)=0 & disjoint(MarkedCells, ExposedCells) & not gameOver & not peeking
      modifies U, UnexposedCells, UnexposedList.Content, MinedCells, ExposedList.Content, ExposedList.setInit, UnexposedList.Iter, init
      calls UnexposedList, ExposedList
      ensures card(ExposedCells') = 0 & disjoint(MarkedCells', ExposedCells') & (UnexposedCells' = UnexposedList.Content');

}
