spec module CL {
    default CG = Board.gameOver | disjoint (Board.MinedCells, Board.ExposedCells);

    proc handleMouse(x1:int; y1:int; 
                     x2:int; y2:int) returns done:bool suspends Board.NP
      requires not Board.gameOver &
               (Board.UnexposedCells <= Board.U) 
      modifies Board.ExposedCells,
               Board.UnexposedCells, 
               Board.MarkedCells, Board.gameOver
      calls View
      ensures (done' <=> Board.gameOver') & 
              (Board.UnexposedCells' <= Board.U') &
              disjoint(Board.MinedCells', Board.ExposedCells');

    proc handleKey(c:char) returns done:bool suspends Board.NP
      requires not Board.gameOver 
      modifies Board.peeking calls Board 
      ensures (done' <=> Board.gameOver') &
              disjoint(Board.MinedCells', Board.ExposedCells');

    proc loop() 
      requires not Board.gameOver &
               (Board.UnexposedCells <= Board.U)
      modifies Board.ExposedCells, 
               Board.UnexposedCells,
               Board.MarkedCells, Board.peeking, Board.gameOver
      calls Controller
      ensures true;
}
