spec module List {
  format Node;
  specvar Content : Node set;
  specvar Iter : Node set;

  invariant Iter in Content;

  proc add(n : Node)
    requires card(n)=1 & not (n in Content)
    modifies Content
    ensures (Content' = Content + n);

  proc remove(n : Node)
    requires card(n)=1 & (n in Content)
    modifies Content, Iter
    ensures (Content' = Content - n) &
            (Iter' = Iter - n);

  proc openIter()
    requires true
    modifies Iter
    ensures (Iter' = Content);

  proc nextIter() returns n : Node
    requires (card(Iter) >= 1)
    modifies Iter
    ensures card(n')=1 & 
        (n' in Iter) & (Iter' = Iter - n') &
        (n' in Content);

  proc closeIter()
    modifies Iter
    ensures card(Iter') = 0;

  proc isLastIter() returns e : bool
    ensures (not e' <=> (card(Iter') >= 1));
}
