spec module Sockets {
  format Socket;

  specvar Init : Socket set;
  specvar Open : Socket set;
  specvar Readable : Socket set;
  specvar Writable : Socket set;
  specvar OpenReadableWritable : Socket set;

  proc openRead(s : Socket)
    requires card(s)=1 & not (s in Open) & not (s in Init) &
             (Readable in Open) & (Writable in Open) 
    modifies Readable, Open, OpenReadableWritable, Init
    ensures (Init' = Init + s) &
            (Open' = Open + s) &
            (Readable' = Readable + s) &
            (Readable' in Open') &
            (Writable' in Open');
/*
  proc openWrite(s : Socket)
    requires card(s)=1 & not (s in Open) &
             (Readable in Open) & (Writable in Open)
    modifies Writable, Open, OpenReadableWritable, Init
    ensures (Open' = Open + s) &
            (Writable' = Writable + s) &
            (Readable' in Open') &
            (Writable' in Open');

  proc openReadWrite(s : Socket)
    requires card(s)=1 & not (s in Open) &
             (Readable in Open) & (Writable in Open)
    modifies Readable, Writable, Open, OpenReadableWritable, Init
    ensures (Open' = Open + s) &
            (Readable' = Readable + s) &
            (Writable' = Writable + s) &
            (Readable' in Open') &
            (Writable' in Open');*/
}
