spec module Pipe {
  format P;
  specvar CR: P set;
  specvar CW: P set;
  /* (write | read)* writerClose read* eof()=true readerClose */
  proc read(p:P) 
    requires not (p in CR)
    ensures true;
  proc write(p:P)
    requires not (p in CW)
    ensures true;
  proc writerClose(p:P)
    requires not (p in CR)
    modifies CW
    ensures (CW' = CW + p);
  proc eof(p:P) returns rv:bool 
    ensures rv' => (p in CW);
  proc readerClose(p:P) 
    requires (p in CW)
    modifies CR
    ensures (CR' = CR + p);
}
