spec module Stack = SLLStack;

spec module Data
{
    format Entry;

    proc setValue(e:Entry; nv:int) ensures true;
    proc getValue(e:Entry) returns nv:int ensures true;
}

spec module Producer
{
    format Entry;

    proc produce() 
      modifies Stack.S 
      calls Stack, Data
      ensures exists g:Entry. 
                ((not (g in Stack.S)) & (g in Stack.S') & card(g) = 1);
}

spec module Consumer
{
    format Entry;

    proc consume() 
      requires not (card(Stack.S) = 0) modifies Stack.S 
      calls Stack, Data
      ensures exists h:Entry. 
                ((Stack.S' = Stack.S - h) & card(h) = 1);

    proc canConsume() returns cc:bool
      calls Stack
      ensures cc' <=> not (card(Stack.S) = 0);
}

spec module Main
{
    proc main() modifies Stack.S calls Producer, Consumer ensures true;
}
