spec module Map
{
  format Key;
  format Value;

  specvar r : (Key * Value) set;

  default I = "\<forall> k v1 v2. (k,v1) \<in> r \<and> (k,v2) \<in> r --> v1=v2";

  proc update(k:Key; v:Value)
    modifies r
    ensures "r = old(r) - {(k,v1)| True} \<union> {(k,v)}";

  proc lookup(k:Key) returns v:Value
    ensures "(v = null \<and> \<forall> v1. (k,v1) \<notin> r) \<or>
             (v \<noteq> null \<and> (k,v) \<in> r)";
}
