spec module Rel {
  /* A mutable binary static relation between A and B */

  format A;
  format B;

  specvar r : (A * B) set;

  proc insert(a:A; b:B)
    requires "a \<noteq> null \<and> b \<noteq> null"
    modifies Rel.r
    ensures "Rel.r' = Rel.r \<union> {(a,b)}";

  proc remove(a:A; b:B)
    requires "a \<noteq> null \<and> b \<noteq> null"
    modifies r
    ensures "r' = r - {(a,b)}";

  proc member(a:A; b:B) returns isMember:bool
    requires "a \<noteq> null \<and> b \<noteq> null"
    ensures "isMember = ((a,b) \<in> r)";

  proc getValue(a:A) returns b:B
    requires "a \<noteq> null"
    ensures "((\<exists> b1. (a,b1) \<in> r) --> 
                 b \<noteq> null & (a,b) \<in> r) \<and> 
             (\<not> (\<exists> b1. (a,b1) \<in> r) --> b = null)";
}
