spec module PriorityQueue {
  format PQEntry;
  specvar PQ : PQEntry set;

  proc init()
    modifies PQ
    ensures "PQ' = \<emptyset>";

  proc isEmpty() returns b:bool
    ensures "b = (PQ = \<emptyset>)";

  proc insert(n:PQEntry; p1:int)
    requires "n \<noteq> null \<and> n \<notin> PQ"
    modifies PQ
    ensures "PQ' = PQ \<union> {n}";

  proc findMax() returns n:PQEntry
    ensures "(PQ = \<emptyset> \<longrightarrow> n = null) \<and>
             (PQ \<noteq> \<emptyset> \<longrightarrow> n \<in> PQ)";


  proc extractMax() returns n:PQEntry
    requires "PQ \<noteq> \<emptyset>"
    modifies PQ
    ensures "n \<in> PQ \<and> 
             PQ' = PQ - {n}";

  private proc swap(a:int; b:int)
    ensures "True";

  private proc bubbleDown(i:int)
    ensures "True";

}
