spec module DLL {
  format Node;
  specvar Content : Node set;

  proc remove(e : Node)
    requires card(e)=1 & (e in Content)
    modifies Content
    ensures (Content' = Content - e);

  proc removeFirst() returns n:Node
    requires card(Content)>=1
    modifies Content
    ensures card(n')=1 & (Content' = Content - n') & (n' in Content);

  proc addLast(p : Node) 
    requires card(p)=1 & not (p in Content)
    modifies Content
    ensures Content' = Content + p;

  proc clear()
    modifies Content
    ensures card(Content') = 0;

  proc contains(e : Node) returns b:bool
    requires card(e) = 1
    ensures (b' <=> (e' in Content));

  proc getFirst() returns e:Node
    requires card(Content)>=1
    ensures card(e')=1 & (e' in Content);

  proc isEmpty() returns rv:bool
    ensures rv' <=> (card(Content) = 0);
}
