spec module vc3 {
    format Node;

    specvar setInit : bool;
    specvar Content : Node set;
    specvar full : bool;

    proc init() 
      requires true 
      modifies Content, setInit, full
      ensures setInit' & not full';

    proc isFull() returns res : bool
      requires true
      ensures res <=> full;

    proc add(e:Node) 
      requires setInit & (not full) & card(e) = 1
      modifies Content, full
      ensures (Content' = Content + e);

    proc remove(e:Node) 
      requires setInit & (not full)
      modifies Content
      ensures (Content' = Content - e);

    proc contains(e:Node) returns b:bool
      requires setInit & (not full) & card(e)=1 
      ensures b <=> (e in Content);

}
