theory "vc3-lemmas" = ArrayVC:

lemma intervalDiff:
   "(0 <= b) ==> {x. EX (j::int). x : f j & j < b + 1 & 0 <= j} = {x. EX (j::int). x : f j & j < b & 0 <= j} Un f b"
apply auto
apply (case_tac "j=b")
apply auto
done

lemma four_new: 
"([|((arrayRead d' i') = e);
(i' < s);
((0::int) <= i');
(i' <= s);
(ALL j. (((j < s) & (i' <= j)) --> ((arrayRead d' j) = (arrayRead d j))));
({x. (EX j. ((x : (arrayRead d' j)) & (j < i') & ((0::int) <= j)))} = ({x. (EX j. ((x : (arrayRead d j)) & (j < i') & ((0::int) <= j)))} - e));
(ALL i. (cardleq1 (arrayRead d i)));
(cardleq1 e);
((0::int) <= s);
setInit|] ==>
    ({x. (EX j. ((x : (arrayRead (arrayWrite d' i' nullObj) j)) & (j < (i' + (1::int))) & ((0::int) <= j)))} = ({x. (EX j. ((x : (arrayRead d j)) & (j < (i' + (1::int))) & ((0::int) <= j)))} - e)))"
(* Proof4 *)
apply auto
 (* 1 *)
apply (case_tac "j=i'")
apply (simp add: array1_def)  (* solved j=i' *)
apply (subgoal_tac "j < i'")
prefer 2
apply simp
apply (subgoal_tac "x : arrayRead d' j")
prefer 2
apply (simp add: array2_def)
apply (subgoal_tac "x : {x. EX j. x : arrayRead d' j & j < i' & 0 <= j}")
prefer 2
apply force
apply (subgoal_tac "x : {x. EX j. x : arrayRead d j & j < i' & 0 <= j}")
prefer 2
apply simp (* and finally: *)
apply simp
apply force
  (* 2 *)
apply (case_tac "j=i'")
apply (simp add: array1_def)  (* solved j=i' *)
apply (subgoal_tac "j < i'")
prefer 2
apply simp
apply (subgoal_tac "x : arrayRead d' j")
prefer 2
apply (simp add: array2_def)
apply (subgoal_tac "x : {x. EX j. x : arrayRead d' j & j < i' & 0 <= j}")
prefer 2
apply force
apply force
  (* 3 *)
apply (case_tac "j=i'")
apply (simp add: array1_def)  (* solved j=i' *)
apply (subgoal_tac "j < i'")
prefer 2
apply simp
apply (subgoal_tac "x : {x. EX j. x : arrayRead d j & j < i' & 0 <= j}")
prefer 2
apply force
apply (subgoal_tac "x : {x. EX j. x : arrayRead d' j & j < i' & 0 <= j}")
prefer 2
apply simp
apply safe
apply (rule_tac x="jb" in exI)
apply (simp add: array2_def)
done

lemma add_old: "[|
((0::int) <= s);
setInit;
cardeq1 e|] ==>
({x. (EX j. ((x : (arrayRead (arrayWrite d s e) j)) & (j < (s + (1::int))) & ((0::int) <= j)))} = ({x. (EX j. ((x : (arrayRead d j)) & (j < s) & ((0::int) <= j)))} Un e))"
apply auto
apply (rule_tac x="j" in exI)
apply (case_tac "j=s")
apply (simp add: array1_def array2_def)
apply (simp add: array1_def array2_def)
apply (rule_tac x="j" in exI)
apply (simp add: array1_def array2_def)
apply (rule_tac x="s" in exI)
apply (simp add: array1_def array2_def)
done

lemma add: "([|((0::int) <= s);
setInit;
cardeq1 e|] ==>
    ({x. (EX j. ((x : (arrayRead (arrayWrite d s e) j)) & (j < (s + (1::int))) & ((0::int) <= j)))} = ({x. (EX j. ((x : (arrayRead d j)) & (j < s) & ((0::int) <= j)))} Un e)))"
apply auto
apply (rule_tac x="j" in exI)
apply (case_tac "j=s")
apply (simp add: array1_def array2_def)
apply (simp add: array1_def array2_def)
apply (rule_tac x="j" in exI)
apply (simp add: array1_def array2_def)
apply (rule_tac x="s" in exI)
apply (simp add: array1_def array2_def)
done


lemma contains14: "[|
(~((i' < s) & (~res')));
((0::int) <= i');
(i' <= s);
(d = d);
(res' = (e <= {x. (EX j. ((x : (arrayRead d j)) & (j < i') & ((0::int) <= j)))}));
(ALL i. (cardleq1 (arrayRead d i)));
(cardleq1 e);
((0::int) <= s);
setInit;
cardeq1 e|] ==>
((res') = ((e <= {x. (EX j. ((x : (arrayRead d j)) & (j < s) & ((0::int) <= j)))})))"
apply (case_tac "i'=s")
apply auto
apply (subgoal_tac "x : {x. EX j. x : arrayRead d j & j < i' & 0 <= j}")
prefer 2
apply force
apply auto
done

lemma neqDisj: "[| cardleq1 x; cardleq1 y; x ~= y |] ==> x Int y = {}"
by (auto simp add: cardleq1_def)

lemma notSubDisj: "[| cardleq1 x; ~(x <= A) |] ==> x Int A = {}"
by (auto simp add: cardleq1_def)

lemma disjEq1NotSub: "[| cardeq1 x; x Int A = {} |] ==> ~(x <= A)"
by (auto simp add: cardeq1_def)

lemma intervalDiff:
   "(0 <= b) ==> {x. EX (j::int). x : f j & j < b + 1 & 0 <= j} = {x. EX (j::int). x : f j & j < b & 0 <= j} Un f b"
apply auto
apply (case_tac "j=b")
apply auto
done

lemma contains8: "[|
(~((arrayRead d i') = e));
(~res');
(i' < s);
((0::int) <= i');
(i' <= s);
(d = d);
(res' = (e <= {x. (EX j. ((x : (arrayRead d j)) & (j < i') & ((0::int) <= j)))}));
(ALL i. (cardleq1 (arrayRead d i)));
(cardleq1 e);
((0::int) <= s);
setInit;
cardeq1 e|] ==>
(res' = (e <= {x. (EX j. ((x : (arrayRead d j)) & (j < (i' + (1::int))) & ((0::int) <= j)))}))"
proof -
  let ?A1 = "{x. (EX j. ((x : (arrayRead d j)) & (j < (i' + (1::int))) & ((0::int) <= j)))}"
  let ?A = "{x. (EX j. ((x : (arrayRead d j)) & (j < i') & ((0::int) <= j)))}"
  let ?b = "arrayRead d i'"
  assume hyp: "res' = (e <= ?A)"
  assume nres: "~res'"
  assume eone: "cardleq1 e"
  assume eeone: "cardeq1 e"
  assume ips: "i' < s" 
  assume ipcond: "0 <= i'"
  assume arrone: "ALL i. cardleq1 (arrayRead d i)"
  assume bnote: "~((arrayRead d i') = e)"
  show "res' = (e <= ?A1)"
  proof -
    from nres hyp eone notSubDisj have enin: "e Int ?A = {}" by auto
    from ipcond have d2: "?A1 = ?A Un ?b" by (rule intervalDiff)
    from arrone have bone: "cardleq1 ?b" by auto
    from eone bone bnote have disj: "?b Int e = {}" by (simp add: neqDisj)    
    from d2 enin disj have alldisj:"e Int ?A1 = {}" by auto
    from alldisj nres eeone disjEq1NotSub show ?thesis by auto
  qed
qed

lemma thirteen: "[|
(~(i' < s));
((0::int) <= i');
(i' <= s);
(ALL j. (((j < s) & (i' <= j)) --> ((arrayRead d' j) = (arrayRead d j))));
({x. (EX j. ((x : (arrayRead d' j)) & (j < i') & ((0::int) <= j)))} = ({x. (EX j. ((x : (arrayRead d j)) & (j < i') & ((0::int) <= j)))} - e));
(ALL i. (cardleq1 (arrayRead d i)));
(cardleq1 e);
((0::int) <= s);
setInit|] ==>
({x. (EX j. ((x : (arrayRead d' j)) & (j < s) & ((0::int) <= j)))} = ({x. (EX j. ((x : (arrayRead d j)) & (j < s) & ((0::int) <= j)))} - e))"
by (subgoal_tac "i'=s", auto)

lemma eeeight: "[|
(~((arrayRead d' i') = e));
(i' < s);
((0::int) <= i');
(i' <= s);
(ALL j. (((j < s) & (i' <= j)) --> ((arrayRead d' j) = (arrayRead d j))));
({x. (EX j. ((x : (arrayRead d' j)) & (j < i') & ((0::int) <= j)))} = ({x. (EX j. ((x : (arrayRead d j)) & (j < i') & ((0::int) <= j)))} - e));
(ALL i. (cardleq1 (arrayRead d i)));
(cardleq1 e);
((0::int) <= s);
setInit|] ==>
({x. (EX j. ((x : (arrayRead d' j)) & (j < (i' + (1::int))) & ((0::int) <= j)))} = ({x. (EX j. ((x : (arrayRead d j)) & (j < (i' + (1::int))) & ((0::int) <= j)))} - e))"
proof -
  let ?A1p = "{x. (EX j. ((x : (arrayRead d' j)) & (j < (i' + (1::int))) & ((0::int) <= j)))}"
  let ?Ap = "{x. (EX j. ((x : (arrayRead d' j)) & (j < i') & ((0::int) <= j)))}"
  let ?A1 = "{x. (EX j. ((x : (arrayRead d j)) & (j < (i' + (1::int))) & ((0::int) <= j)))}"
  let ?A = "{x. (EX j. ((x : (arrayRead d j)) & (j < i') & ((0::int) <= j)))}"
  let ?b = "arrayRead d i'"
  let ?bp = "arrayRead d' i'"
  assume hyp: "?Ap = (?A - e)"
  assume ipcond: "0 <= i'"
  assume ips: "i' < s"
  assume frame: "ALL j. (((j < s) & (i' <= j)) --> ((arrayRead d' j) = (arrayRead d j)))"
  assume eone: "cardleq1 e"
  assume arrone: "ALL i. cardleq1 (arrayRead d i)"
  assume bnote: "~((arrayRead d' i') = e)"
  show "?A1p = (?A1 - e)"
  proof -
    from ipcond have d1: "?A1p = ?Ap Un ?bp" by (rule intervalDiff)
    from ipcond have d2: "?A1 = ?A Un ?b" by (rule intervalDiff)
    from ips frame have arrEq: "?bp = ?b" by auto
    from arrone have bone: "cardleq1 ?b" by auto
    from arrEq eone bone bnote have disj: "?b Int e = {}" by (simp add: neqDisj)
    from d1 d2 arrEq hyp disj show ?thesis by auto
  qed
qed


lemma contra: "[| x ~: e; x : arrayRead (arrayWrite d s e) i |] ==> i ~= s"
apply safe
apply (simp add: array1_def)
done


lemma add: "[|
((0::int) <= s);
setInit;
cardeq1 e|] ==>
({x. (EX j. ((x : (arrayRead (arrayWrite d s e) j)) & (j < (s + (1::int))) & ((0::int) <= j)))} = ({x. (EX j. ((x : (arrayRead d j)) & (j < s) & ((0::int) <= j)))} Un e))"
apply auto
apply (rule_tac x="j" in exI)
apply (case_tac "j=s")
apply (simp add: array1_def array2_def)
apply (simp add: array1_def array2_def)
apply (rule_tac x="j" in exI)
apply (simp add: array1_def array2_def)
apply (rule_tac x="s" in exI)
apply (simp add: array1_def array2_def)
done

lemma four: "[|
((arrayRead d' i') = e);
(i' < s);
((0::int) <= i');
(i' <= s);
(ALL j. (((j < s) & (i' <= j)) --> ((arrayRead d' j) = (arrayRead d j))));
({x. (EX j. ((x : (arrayRead d' j)) & (j < i') & ((0::int) <= j)))} = ({x. (EX j. ((x : (arrayRead d j)) & (j < i') & ((0::int) <= j)))} - e));
(ALL i. (cardleq1 (arrayRead d i)));
(cardleq1 e);
((0::int) <= s);
setInit|] ==>
({x. (EX j. ((x : (arrayRead (arrayWrite d' i' {}) j)) & (j < (i' + (1::int))) & ((0::int) <= j)))} = ({x. (EX j. ((x : (arrayRead d j)) & (j < (i' + (1::int))) & ((0::int) <= j)))} - e))"
(* Proof4 *)
apply auto
 (* 1 *)
apply (case_tac "j=i'")
apply (simp add: array1_def)  (* solved j=i' *)
apply (subgoal_tac "j < i'")
prefer 2
apply simp
apply (subgoal_tac "x : arrayRead d' j")
prefer 2
apply (simp add: array2_def)
apply (subgoal_tac "x : {x. EX j. x : arrayRead d' j & j < i' & 0 <= j}")
prefer 2
apply force
apply (subgoal_tac "x : {x. EX j. x : arrayRead d j & j < i' & 0 <= j}")
prefer 2
apply simp (* and finally: *)
apply simp
apply force
  (* 2 *)
apply (case_tac "j=i'")
apply (simp add: array1_def)  (* solved j=i' *)
apply (subgoal_tac "j < i'")
prefer 2
apply simp
apply (subgoal_tac "x : arrayRead d' j")
prefer 2
apply (simp add: array2_def)
apply (subgoal_tac "x : {x. EX j. x : arrayRead d' j & j < i' & 0 <= j}")
prefer 2
apply force
apply force
  (* 3 *)
apply (case_tac "j=i'")
apply (simp add: array1_def)  (* solved j=i' *)
apply (subgoal_tac "j < i'")
prefer 2
apply simp
apply (subgoal_tac "x : {x. EX j. x : arrayRead d j & j < i' & 0 <= j}")
prefer 2
apply force
apply (subgoal_tac "x : {x. EX j. x : arrayRead d' j & j < i' & 0 <= j}")
prefer 2
apply simp
apply safe
apply (rule_tac x="jb" in exI)
apply (simp add: array2_def)
done

lemma eight: "[|
(~((arrayRead d' i') = e));
(i' < s);
((0::int) <= i');
(i' <= s);
(ALL j. (((j < s) & (i' <= j)) --> ((arrayRead d' j) = (arrayRead d j))));
({x. (EX j. ((x : (arrayRead d' j)) & (j < i') & ((0::int) <= j)))} = ({x. (EX j. ((x : (arrayRead d j)) & (j < i') & ((0::int) <= j)))} - e));
(ALL i. (cardleq1 (arrayRead d i)));
(cardleq1 e);
((0::int) <= s);
setInit|] ==>
({x. (EX j. ((x : (arrayRead d' j)) & (j < (i' + (1::int))) & ((0::int) <= j)))} = ({x. (EX j. ((x : (arrayRead d j)) & (j < (i' + (1::int))) & ((0::int) <= j)))} - e))"
apply (subgoal_tac "{x. EX j. x : arrayRead d' j & j < i' + 1 & 0 <= j} = {x. EX j. x : arrayRead d' j & j < i' & 0 <= j} Un arrayRead d' i'")
prefer 2
apply (rule intervalDiff)
apply simp
apply (subgoal_tac "{x. EX j. x : arrayRead d j & j < i' + 1 & 0 <= j} = {x. EX j. x : arrayRead d j & j < i' & 0 <= j} Un arrayRead d i'")
prefer 2
apply (rule intervalDiff)
apply simp
apply (auto simp add: cardleq1_def)
done

lemma twelve: "[|
(~(i' < s));
((0::int) <= i');
(i' <= s);
(ALL j. (((j < s) & (i' <= j)) --> ((arrayRead d' j) = (arrayRead d j))));
({x. (EX j. ((x : (arrayRead d' j)) & (j < i') & ((0::int) <= j)))} = ({x. (EX j. ((x : (arrayRead d j)) & (j < i') & ((0::int) <= j)))} - e));
(ALL i. (cardleq1 (arrayRead d i)));
(cardleq1 e);
((0::int) <= s);
setInit|] ==>
({x. (EX j. ((x : (arrayRead d' j)) & (j < s) & ((0::int) <= j)))} = ({x. (EX j. ((x : (arrayRead d j)) & (j < s) & ((0::int) <= j)))} - e))"
(* Proof12 *)
by (subgoal_tac "i'=s", auto)

end
